;=== Defines
!define APP64 VueScan64
!define INI    `${SET}\vuescan.ini`
!define DEFINI `${DEFDATA}\settings\vuescan.ini`
;===
!define 32    VueScan\vuescan.exe
!define 64    VueScan64\vuescan.exe
;===
!define EXE32 `$EXEDIR\App\${32}`
!define EXE64 `$EXEDIR\App\${64}`
;===
!define SET32 `Kernel32::SetEnvironmentVariable(t "VUESCAN", t "VueScan")`
!define SET64 `Kernel32::SetEnvironmentVariable(t "VUESCAN", t "VueScan64")`
;===
!define XML    `${DATA}\config\config.xml`
!define DEFXML `${DEFDATA}\config\config.xml`
!define XPATH  `/cfg/section[@name="Language"]/File`
;===
;!define DOC    `${DATA}\My Documents`
;===
;!define LOGS   `${DATA}\logs`
;===
;!define CFG    `${DATA}\config`
;!define DEFCFG `${DEFDATA}\config`
;===
!define PFM    `$R0\PortableApps.com\PortableAppsPlatform.exe`
;===
Function GetLCID
	!macro _GetLCID _LNG _LCID
		Push ${_LNG}
		Call GetLCID
		Pop ${_LCID}
	!macroend
	!define GetLCID "!insertmacro _GetLCID"
	Exch $R0
	StrCmp $R0 bGFuZy1lbi54bWw= 0 +3
	StrCpy $R0 1033
		Goto EndLCID
	StrCmp $R0 bGFuZy1mci54bWw= 0 +3
	StrCpy $R0 1036
		Goto EndLCID
	StrCmp $R0 bGFuZy1kZS54bWw= 0 +3
	StrCpy $R0 1031
		Goto EndLCID
	StrCmp $R0 bGFuZy1lcy54bWw= 0 +3
	StrCpy $R0 1034
		Goto EndLCID
	StrCmp $R0 bGFuZy1jbi54bWw= 0 +3
	StrCpy $R0 2052
		Goto +2
	StrCpy $R0 1033
	EndLCID:
	Exch $R0
FunctionEnd
Function GetLNG
	!macro _GetLNG _LCID _LNG
		Push ${_LCID}
		Call GetLNG
		Pop ${_LNG}
	!macroend
	!define GetLNG "!insertmacro _GetLNG"
	Exch $R0
	StrCmp $R0 1033 0 +3
	StrCpy $R0 bGFuZy1lbi54bWw=
		Goto EndLNG
	StrCmp $R0 1036 0 +3
	StrCpy $R0 bGFuZy1mci54bWw=
		Goto EndLNG
	StrCmp $R0 1031 0 +3
	StrCpy $R0 bGFuZy1kZS54bWw=
		Goto EndLNG
	StrCmp $R0 1034 0 +3
	StrCpy $R0 bGFuZy1lcy54bWw=
		Goto EndLNG
	StrCmp $R0 2052 0 +3
	StrCpy $R0 bGFuZy1jbi54bWw=
		Goto +2
	StrCpy $R0 error
	EndLNG:
	Exch $R0
FunctionEnd
;=== Custom
${SegmentFile}
${Segment.OnInit}
	Push $0
	${IsWOW64} $0
	StrCmp $0 0 ThirtyTwoBit
	IfFileExists `${EXE64}` 0 EightySixBit
	SetRegView 64
	System::Call `${SET64}`
	${WriteSettings} 64 Architecture
		Goto END
	EightySixBit:
	System::Call `${SET32}`
	${WriteSettings} 64 Architecture
		Goto END
	ThirtyTwoBit:
	System::Call `${SET32}`
	${WriteSettings} 32 Architecture
	END:
	Pop $0
!macroend
;===
!macro ProExecInit
	Push $0
	ReadEnvStr $0 ${APP}
	StrCmp $0 ${APP} 0 +3
	StrCpy $ProgramExecutable ${32}
	Goto +2
	StrCpy $ProgramExecutable ${64}
	Pop $0
!macroend
;===
!define MsgBox "!insertmacro MsgBox"
!macro MsgBox
	StrCpy $0 `Windows Vista +`
	MessageBox MB_ICONSTOP|MB_TOPMOST `$(MINREQ)`
	Call Unload
	Quit
!macroend
!macro OS
	Push $0
	${If} ${IsNT}
		${IfNot} ${AtLeastWinVista}
			${MsgBox}
		${EndIf}
	${Else}
		${MsgBox}
	${EndIf}
	Pop $0
!macroend
;===
!define PortableApps.comLocaleID "!insertmacro PortableApps.comLocaleID"
!macro PortableApps.comLocaleID
	${If} ${FileExists} `${XML}`
		${XMLReadText} `${XML}` `${XPATH}` $R0
	${Else}
		${XMLReadText} `${DEFXML}` `${XPATH}` $R0
	${EndIf}
	${GetLCID} $R0 $R0
	${SetEnvironmentVariable} PortableApps.comLocaleID $R0
!macroend
!macro Lang
	Push $R0
	${GetParent} `$EXEDIR` $R0
	${If} ${FileExists} `${PFM}`
		ReadEnvStr $R0 PortableApps.comLocaleID
		${GetLNG} $R0 $R0
		${If} $R0 == error
			${PortableApps.comLocaleID}
		${EndIf}
	${Else}
		${PortableApps.comLocaleID}
	${EndIf}
	Pop $R0
!macroend
;===
!macro LangInit
	Push $R0
	ReadEnvStr $R0 PortableApps.comLocaleID
	${GetLNG} $R0 $R0
	${SetEnvironmentVariable} PAL:LanguageCustom $R0
	Pop $R0
!macroend
;===
!macro Init
	IfFileExists `${INI}` +2
	CopyFiles /SILENT `${DEFINI}` `${INI}`
!macroend

${SegmentPostPrimary}
	SetRegView 64
	DeleteRegKey /IFEMPTY HKLM `SOFTWARE\Vuescan\path`
        DeleteRegKey /IFEMPTY HKLM `SOFTWARE\Vuescan`
        DeleteRegKey /IFEMPTY HKCU `SOFTWARE\Microsoft\ActiveMovie\Filter Cache64`
        DeleteRegKey /IFEMPTY HKCU `SOFTWARE\Microsoft\ActiveMovie\Filter Cache`
        DeleteRegKey /IFEMPTY HKCU `SOFTWARE\Microsoft\ActiveMovie`
        	Pop $0
		SetRegView LastUsed
!macroend

